Attribute VB_Name = "ModuleAPI"
Option Explicit

Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type OPENFILENAME
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
Public Const HWND_TOPMOST As Long = -1, SWP_NOSIZE = &H1, SWP_NOMOVE = &H2

Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_FILEMUSTEXIST = &H1000

Public Declare Function ShellExecute Lib _
              "shell32.dll" Alias "ShellExecuteA" _
              (ByVal hWnd As Long, _
               ByVal lpOperation As String, _
               ByVal lpFile As String, _
               ByVal lpParameters As String, _
               ByVal lpDirectory As String, _
               ByVal nShowCmd As Long) As Long
               
Private Declare Function GetOpenFileNameA Lib "comdlg32.dll" (pOpenfilename As OPENFILENAME) As Long

Public Const SW_HIDE = 0
Public Const SW_NORMAL = 1
Public Const SW_MAXIMIZE = 3
Public Const SW_SHOWNOACTIVATE = 4
Public Const SW_SHOW = 5
Public Const SW_MINIMIZE = 6
Public Const SW_SHOWMINNOACTIVE = 7

Public Const SE_ERR_FNF = 2                     '  file not found
Public Const SE_ERR_PNF = 3                     '  path not found
Public Const SE_ERR_ACCESSDENIED = 5            '  access denied
Public Const SE_ERR_OOM = 8                     '  out of memory
Public Const ERROR_BAD_FORMAT = 11
Public Const SE_ERR_ASSOCINCOMPLETE = 27
Public Const SE_ERR_DLLNOTFOUND = 32
Public Const SE_ERR_NOASSOC = 31
Public Const SE_ERR_SHARE = 26


Public Const SND_ASYNC = &H1      ' Play asynchronously
Public Const SND_NODEFAULT = &H2  ' Don't use default sound
Public Const SND_MEMORY = &H4    ' lpszSoundName points to a memory file
Public Const SND_FILENAME& = &H20000

Private Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" _
        (lpszSoundName As Any, ByVal uFlags As Long) As Long

Public Declare Function SetWindowPos& Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long

Private Declare Function GetPrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function SystemParametersInfoA Lib "user32" _
        (ByVal uAction As Long, ByVal uParam As Long, lpvParam As RECT, ByVal fuWinIni As Long) As Long

Public sCurrentScin As String, bExit As Boolean, bSmallSize As Boolean

Public Sub GetScreenRect(rc As RECT)
    Const SPI_GETWORKAREA As Long = 48
    SystemParametersInfoA SPI_GETWORKAREA, 0, rc, 0
    rc.Left = rc.Left * Screen.TwipsPerPixelX
    rc.Right = rc.Right * Screen.TwipsPerPixelX
    rc.Top = rc.Top * Screen.TwipsPerPixelY
    rc.Bottom = rc.Bottom * Screen.TwipsPerPixelY
End Sub

Public Function GetPrivateProfileString(ByVal Section As String, ByRef Key As String, Optional ByRef Default As String = "", Optional ByRef Typ As String = "S") As String
    Static OldSection As String, s As String
    Dim KeyValue As String * 128, i As Long
    If Section = "" Then
        Section = OldSection
    Else
        OldSection = Section
    End If
    i = GetPrivateProfileStringA(Section, Key, Default, KeyValue, 127, App.Path & "\Scins\" & sCurrentScin & "\Scin" & IIf(bSmallSize, "S", "") & ".ini")
    If i >= 1 Then
        s = Left$(KeyValue, i)
        Select Case UCase$(Typ)
            Case "S"
                GetPrivateProfileString = s
            Case "N"
                If IsNumeric(s) Then
                    GetPrivateProfileString = s
                Else
                    GetPrivateProfileString = Default
                End If
            Case "D"
                If IsDate(s) Then
                    GetPrivateProfileString = s
                Else
                    GetPrivateProfileString = Default
                End If
        End Select
    End If
End Function

Public Function IsFile(sPathFile As String) As Boolean
    Dim iHFile As Integer
    On Error GoTo err_IsFile
    iHFile = FreeFile
    Open sPathFile For Input As #iHFile
    Close #iHFile
    IsFile = True
err_IsFile:
    Exit Function
End Function

Public Function FileOpenDialog(ByVal hWndOwner As Long, ByVal Filter As String, ByVal Title As String, ByVal InitDir As String, Optional ByVal strFileDefault As String = "") As String
    Dim ofn As OPENFILENAME, i As Long

    ofn.lpstrFile = strFileDefault & Space$(254 - Len(strFileDefault))
    ofn.lStructSize = Len(ofn)
    ofn.hWndOwner = hWndOwner
    ofn.hInstance = App.hInstance
    ofn.nMaxFile = 255
    ofn.lpstrFileTitle = Space$(254)
    ofn.nMaxFileTitle = 255
    ofn.lpstrInitialDir = InitDir
    ofn.lpstrTitle = Title
    ofn.flags = OFN_HIDEREADONLY Or OFN_FILEMUSTEXIST
    ofn.lpstrFilter = FilterForDialog(Filter)
    ofn.nFilterIndex = 1
    i = GetOpenFileNameA(ofn)

    If (i) Then
        i = InStr(ofn.lpstrFile, Chr(0))
        If i > 0 Then
            FileOpenDialog = Trim$(Left$(ofn.lpstrFile, i - 1))
        Else
            FileOpenDialog = Trim$(ofn.lpstrFile)
        End If
    End If
End Function

Private Function FilterForDialog(ByVal strFilter As String) As String
    Dim i As Integer, j As Integer
    strFilter = Trim$(strFilter)
    If Len(strFilter) = 0 Then Exit Function
    For i = Len(strFilter) To 0 Step -1
        If Mid$(strFilter, i, 1) <> "|" Then Exit For
    Next i
    strFilter = Left$(strFilter, i)
    If Len(strFilter) = 0 Then Exit Function
    i = 0
    Do
        i = InStr(i + 1, strFilter, "|"): If i = 0 Then Exit Do
        If i > 0 Then Mid$(strFilter, i, 1) = Chr(0)
    Loop
    strFilter = strFilter & Chr(0) & Chr(0)
    FilterForDialog = strFilter
End Function

Public Sub BeginPlaySound(ByVal sFileName As String)
    PlaySound sFileName, 0, SND_ASYNC Or SND_FILENAME Or SND_NODEFAULT
End Sub

Public Sub EndPlaySound()
    PlaySound ByVal vbNullString, 0, 0
End Sub

