VERSION 5.00
Begin VB.UserControl AfTIcon 
   ClientHeight    =   540
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   510
   InvisibleAtRuntime=   -1  'True
   Picture         =   "TrayIcon.ctx":0000
   ScaleHeight     =   540
   ScaleWidth      =   510
End
Attribute VB_Name = "AfTIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type NOTIFYICONDATA_TYPE
    cbSize As Long
    hWnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" _
    (ByVal dwMessage As Long, lpData As NOTIFYICONDATA_TYPE) As Long

Private mvarSysTray As NOTIFYICONDATA_TYPE
Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4
Private Const WM_MOUSEMOVE = &H200
Private booShow As Boolean

Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_RBUTTONDBLCLK = &H206
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205

Event Click(Button As Integer) 'MappingInfo=UserControl,UserControl,-1,Click
Event DblClick(Button As Integer) 'MappingInfo=UserControl,UserControl,-1,DblClick

Public Property Let ToolTip(ByVal strToolTip As String)
    If strToolTip = "" Then
        mvarSysTray.szTip = vbNullChar
    Else
        mvarSysTray.szTip = " " & strToolTip & " " & vbNullChar
    End If
    If booShow Then Shell_NotifyIcon NIM_MODIFY, mvarSysTray
    PropertyChanged "ToolTip"
End Property

Public Property Get ToolTip() As String
    ToolTip = mvarSysTray.szTip
End Property

Public Property Let Icon(ByVal lngIcon As Long)
    If lngIcon = 0 Then Hide
    mvarSysTray.hIcon = lngIcon
    If booShow Then Shell_NotifyIcon NIM_MODIFY, mvarSysTray
    PropertyChanged "Icon"
End Property

Public Property Get Icon() As Long
    Icon = mvarSysTray.hIcon
End Property

Public Function Hide()
    If booShow Then Shell_NotifyIcon NIM_DELETE, mvarSysTray: booShow = False
End Function

Public Sub Show()
    If Not booShow And Icon <> 0 Then
        mvarSysTray.cbSize = Len(mvarSysTray)
        mvarSysTray.hWnd = UserControl.hWnd
        mvarSysTray.uID = 1&
        mvarSysTray.uFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP
        mvarSysTray.uCallbackMessage = WM_MOUSEMOVE
        Shell_NotifyIcon NIM_ADD, mvarSysTray
        'set status
        booShow = True
    End If
End Sub

Private Sub UserControl_InitProperties()
    UserControl.Picture = Picture
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Static rec As Boolean
    If rec = False Then
        rec = True
        Select Case X / Screen.TwipsPerPixelX
            Case WM_LBUTTONDBLCLK
                RaiseEvent DblClick(vbLeftButton)
            Case WM_LBUTTONDOWN
                RaiseEvent Click(vbLeftButton)
'            Case WM_LBUTTONUP
            Case WM_RBUTTONDBLCLK
                RaiseEvent DblClick(vbRightButton)
            Case WM_RBUTTONDOWN
                RaiseEvent Click(vbRightButton)
'            Case WM_RBUTTONUP
        End Select
        rec = False
    End If
End Sub

Private Sub UserControl_Resize()
    Height = 500: Width = 500
End Sub

Private Sub UserControl_Terminate()
    If booShow Then Hide
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "ToolTip", mvarSysTray.szTip, vbNullChar
    PropBag.WriteProperty "Icon", mvarSysTray.hIcon, 0
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    mvarSysTray.szTip = PropBag.ReadProperty("ToolTip", mvarSysTray.szTip)
    mvarSysTray.hIcon = PropBag.ReadProperty("Icon", 0)
End Sub
